import 'dart:ffi' as ffi;
import 'dart:ffi';
import 'dart:io';

ffi.DynamicLibrary _lib = Platform.isAndroid
    ? ffi.DynamicLibrary.open('libmyapplicationnativec.so')
    : ffi.DynamicLibrary.process();

final int Function(int x, int y) nativeAdd =
_lib.lookup<NativeFunction<Int32 Function(Int32, Int32)>>("native_add").asFunction();

final void Function() initEngine =
_lib.lookup<NativeFunction<Void Function()>>("init_engine").asFunction();
