import 'package:flutter/material.dart';
import 'package:permission_handler/permission_handler.dart';

import 'native_add.dart';

class CheckStorge extends StatefulWidget {
  @override
  State<StatefulWidget> createState() => _checkStorage();
}

class _checkStorage extends State<CheckStorge> {
  @override
  Widget build(BuildContext context) {
    return TextButton(onPressed: () async {
      var status = await Permission.manageExternalStorage.status;
      //chưa cấp quyền
      if (!status.isGranted) {
        await Permission.manageExternalStorage.request();
        status = await Permission.manageExternalStorage.status;
        // Kiểm tra xem quyền đã được cấp hay chưa
        if (!status.isGranted) {
          print("khong co quyen");
        }else{
          initEngine();
        }

      }else{
        initEngine();
      }
    }, child: Text('Xin quyen'));
  }
}
