#include <stdint.h>
#include "src/detector/nudedetector.h"
#include <android/log.h>
#define  LOGR(x) __android_log_print(ANDROID_LOG_DEBUG, "flutter", x);
extern "C" __attribute__((visibility("default"))) __attribute__((used))
int32_t native_add(int32_t x, int32_t y) {
    LOGR("test from c")
    return 113;
}


extern "C" __attribute__((visibility("default"))) __attribute__((used))
void init_engine() {
    NudeDetector *nudeEngine = new NudeDetector;
    nudeEngine->modelPath = "/storage/emulated/0/Models/Yolov8/NudeNet/NudeNet.onnx";
    nudeEngine->numThread = 1;
    nudeEngine->modelShape = cv::Size(320,320);
    nudeEngine->inputNodeDims = {1,3,320,320};
    nudeEngine->objectThreshold = 0.2;
    nudeEngine->InitEngine();
    LOGR("init engine done");

    cv::Mat nudeImage = cv::imread("/storage/emulated/0/Models/imageTest/porn.jpg");
    auto firstBlood = CURRENT_MILIS;
    nudeEngine->InferenceEngine(nudeImage);
//    LOGR("first blood: " + std::to_string(CURRENT_MILIS - firstBlood));
    auto start = CURRENT_MILIS;
    uint total=0;
//    for(uint i=0; i < 100 ; i++){
//        nudeEngine->InferenceEngine(nudeImage);
//        total += CURRENT_MILIS-start;
//        start = CURRENT_MILIS;
//    }
//    LOGR("average process time: "  + std::to_string(total/100) + "ms");
LOGR("finished")
}
